.material-icons {
	// stylelint-disable-next-line font-family-no-missing-generic-family-keyword
	font-family: "Material Icons";
	font-weight: normal;
	font-style: normal;
	font-size: 24px;
	line-height: 1;
	letter-spacing: normal;
	text-transform: none;
	display: inline-block;
	white-space: nowrap;
	word-wrap: normal;
	direction: ltr;
	font-feature-settings: "liga";
	-moz-font-feature-settings: "liga";
	-moz-osx-font-smoothing: grayscale;
}

@import "~@angular/material/theming";

@include mat-core();

@mixin my-components-theme($theme) {
	$primary: map-get($theme, primary);
	$accent: map-get($theme, accent);
	$warn: map-get($theme, warn);
	$foreground: map-get($theme, foreground);
	$background: map-get($theme, background);

	.mat-simple-snackbar {
		justify-content: center !important;
	}

	.warning {
		white-space: pre-line;
		text-align: center;
		background-color: mat-color($warn);
	}

	.solved {
		white-space: pre-line;
		text-align: center;
		background-color: mat-color($accent);
	}

	/* for map keys, see https://github.com/angular/material2/blob/master/src/lib/core/theming/_palette.scss */
	tr {
		border-top-color: mat-color($foreground, disabled);
	}

	tr.row_9 {
		border-bottom-color: mat-color($foreground, disabled);
	}

	td {
		border-left-color: mat-color($foreground, disabled);
	}

	td.col_9 {
		border-right-color: mat-color($foreground, disabled);
	}

	td > button {
		color: mat-color($foreground, text) !important;
	}

	td > button:hover:enabled,
	button.digit:hover:enabled {
		background-color: mat-color($background, focused-button);
	}

	td > button.initialClue {
		color: mat-color($foreground, secondary-text) !important;
	}

	.selectedPosition {
		border-color: mat-color($primary) !important;
	}

	.selectedDigit {
		background-color: mix(
			mat-color($background, background),
			mat-color($primary, lighter)
		) !important;
	}

	.lastSolvedField {
		background-color: mix(
			mat-color($background, background),
			mat-color($primary)
		) !important;
	}

	.onlyOnePossibleDigit {
		background-color: mix(
			mat-color($background, background),
			mat-color($accent, lighter)
		) !important;
	}

	.groupForLastSolvedField {
		background-color: mat-color($background, status-bar);
	}
}

// default theme
$candy-app-primary: mat-palette($mat-indigo);
$candy-app-accent: mat-palette($mat-pink, A200, A100, A400);
$candy-app-theme: mat-light-theme($candy-app-primary, $candy-app-accent);

@include angular-material-theme($candy-app-theme);
@include my-components-theme($candy-app-theme);

// light-deeppurple-amber theme
$light-deeppurple-amber-primary: mat-palette($mat-deep-purple);
$light-deeppurple-amber-accent: mat-palette($mat-amber, A200, A100, A400);
$light-deeppurple-amber-theme: mat-light-theme(
	$light-deeppurple-amber-primary,
	$light-deeppurple-amber-accent
);

.light-deeppurple-amber {
	@include angular-material-theme($light-deeppurple-amber-theme);
	@include my-components-theme($light-deeppurple-amber-theme);
}

// dark-pink-bluegrey theme
$dark-pink-bluegrey-primary: mat-palette($mat-pink, 700, 500, 900);
$dark-pink-bluegrey-accent: mat-palette($mat-blue-grey, A200, A100, A400);
$dark-pink-bluegrey-theme: mat-dark-theme(
	$dark-pink-bluegrey-primary,
	$dark-pink-bluegrey-accent
);

.dark-pink-bluegrey {
	@include angular-material-theme($dark-pink-bluegrey-theme);
	@include my-components-theme($dark-pink-bluegrey-theme);
}

// dark-purple-green theme
$dark-purple-green-primary: mat-palette($mat-purple, 700, 500, 800);
$dark-purple-green-accent: mat-palette($mat-green, A200, A100, A400);
$dark-purple-green-theme: mat-dark-theme(
	$dark-purple-green-primary,
	$dark-purple-green-accent
);

.dark-purple-green {
	@include angular-material-theme($dark-purple-green-theme);
	@include my-components-theme($dark-purple-green-theme);
}

// Swanky and Moo Moo
// https://google-webfonts-helper.herokuapp.com/fonts/swanky-and-moo-moo?subsets=latin
// Put the @font-face definitions at the end, because the "url"-string seems to mess up jsbeautifier
@font-face {
	font-family: "Swanky and Moo Moo";
	font-style: normal;
	font-weight: 400;
	font-display: swap;
	src: local("Swanky and Moo Moo"), local("SwankyandMooMoo"),
		url("assets/fonts/swanky-and-moo-moo.woff2") format("woff2");
}

// Material Icons
// https://stackoverflow.com/questions/37270835/how-to-host-material-icons-offline
@font-face {
	font-family: "Material Icons";
	font-style: normal;
	font-weight: 400;
	font-display: block;
	src: local("Material Icons"), local("MaterialIcons"),
		url("assets/fonts/material-icons.woff2") format("woff2");
}

mat-spinner {
	margin: 0 auto;
}

mat-form-field {
	width: 100%;
}
